"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Unstable_DataTable = Unstable_DataTable;

var React = _interopRequireWildcard(require("react"));

var _reactWindow = require("react-window");

var _reactVirtualizedAutoSizer = _interopRequireDefault(require("react-virtualized-auto-sizer"));

var _index = require("../button/index.js");

var _search = _interopRequireDefault(require("../icon/search.js"));

var _index2 = require("../input/index.js");

var _index3 = require("../styles/index.js");

var _index4 = require("../tag/index.js");

var _headerCell = _interopRequireDefault(require("./header-cell.js"));

var _constants = require("./constants.js");

var _measureColumnWidths = _interopRequireDefault(require("./measure-column-widths.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function CellPlacement(_ref) {
  var columnIndex = _ref.columnIndex,
      rowIndex = _ref.rowIndex,
      data = _ref.data,
      style = _ref.style;

  var _useStyletron = (0, _index3.useStyletron)(),
      _useStyletron2 = _slicedToArray(_useStyletron, 2),
      useCss = _useStyletron2[0],
      theme = _useStyletron2[1]; // ignores the table header row


  if (rowIndex === 0) {
    return null;
  }

  var backgroundColor = theme.colors.mono100;

  if (rowIndex % 2 && columnIndex === data.headerHoverIndex || rowIndex === data.rowHoverIndex) {
    backgroundColor = theme.colors.mono300;
  } else if (rowIndex % 2 || columnIndex === data.headerHoverIndex) {
    backgroundColor = theme.colors.mono200;
  }

  var Cell = data.columns[columnIndex].renderCell;
  return React.createElement("div", {
    className: useCss(_objectSpread({}, theme.borders.border200, {
      alignItems: 'center',
      backgroundColor: backgroundColor,
      borderTop: 'none',
      borderBottom: 'none',
      borderLeft: 'none',
      boxSizing: 'border-box',
      display: 'flex'
    })),
    style: style,
    onMouseEnter: function onMouseEnter() {
      return data.onRowHover(rowIndex);
    }
  }, React.createElement(Cell, {
    value: data.rows[rowIndex - 1].data[columnIndex],
    onSelect: data.isSelectable && columnIndex === 0 ? function () {
      return data.onSelect(data.rows[rowIndex - 1].id);
    } : undefined,
    isSelected: data.isRowSelected(data.rows[rowIndex - 1].id),
    textQuery: data.textQuery
  }));
}

function compareCellPlacement(prevProps, nextProps) {
  // no need to re-render column header cells on data changes
  if (prevProps.rowIndex === 0) {
    return true;
  }

  if (prevProps.data.columns !== nextProps.data.columns || prevProps.data.rows !== nextProps.data.rows || prevProps.style !== nextProps.style) {
    return false;
  }

  if (prevProps.data.isSelectable === nextProps.data.isSelectable && prevProps.data.headerHoverIndex === nextProps.data.headerHoverIndex && prevProps.data.rowHoverIndex === nextProps.data.rowHoverIndex && prevProps.data.textQuery === nextProps.data.textQuery && prevProps.data.isRowSelected === nextProps.data.isRowSelected) {
    return true;
  } // at this point we know that the rowHoverIndex or the columnHoverIndex has changed.
  // row does not need to re-render if not transitioning _from_ or _to_ highlighted
  // also ensures that all cells are invalidated on column-header hover


  if (prevProps.rowIndex !== prevProps.data.rowHoverIndex && prevProps.rowIndex !== nextProps.data.rowHoverIndex && prevProps.data.headerHoverIndex === nextProps.data.headerHoverIndex && prevProps.data.isRowSelected === nextProps.data.isRowSelected) {
    return true;
  }

  return false;
}

var CellPlacementMemo = React.memo(CellPlacement, compareCellPlacement);
CellPlacementMemo.displayName = 'CellPlacement';

function useDuplicateColumnTitleWarning(columns) {
  React.useEffect(function () {
    var titles = columns.reduce(function (set, column) {
      return set.add(column.title);
    }, new Set());

    if (titles.size < columns.length) {
      console.warn('Columns titles must be unique else will result in non-deterministic filtering.');
    }
  }, [columns]);
}

function useSortParameters() {
  var _React$useState = React.useState(-1),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      sortIndex = _React$useState2[0],
      setSortIndex = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      sortDirection = _React$useState4[0],
      setSortDirection = _React$useState4[1];

  function handleSort(columnIndex) {
    if (columnIndex === sortIndex) {
      if (sortDirection === _constants.SORT_DIRECTIONS.ASC) {
        setSortIndex(-1);
        setSortDirection(_constants.SORT_DIRECTIONS.DESC);
      } else {
        setSortDirection(_constants.SORT_DIRECTIONS.ASC);
      }
    } else {
      setSortIndex(columnIndex);
      setSortDirection(_constants.SORT_DIRECTIONS.DESC);
    }
  }

  return [sortIndex, sortDirection, handleSort];
}

function useResizeObserver(ref, callback) {
  React.useLayoutEffect(function () {
    if (typeof document !== 'undefined') {
      if (ref.current) {
        var observer = new ResizeObserver(callback);
        observer.observe(ref.current);
        return function () {
          return observer.disconnect();
        };
      }
    }
  }, [ref]);
}

var HeaderContext = React.createContext({
  addFilter: function addFilter() {},
  columns: [],
  filterOpenIndex: -1,
  handleSort: function handleSort() {},
  headerHoverIndex: -1,
  isSelectable: false,
  isSelectedAll: false,
  isSelectedIndeterminate: false,
  onFilterOpen: function onFilterOpen() {},
  onFilterClose: function onFilterClose() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onSelectAll: function onSelectAll() {},
  onSelectNone: function onSelectNone() {},
  rows: [],
  sortIndex: -1,
  sortDirection: null,
  widths: []
});
HeaderContext.displayName = 'HeaderContext'; // replaces the content of the virtualized window with contents. in this case,
// we are prepending a table header row before the table rows (children to the fn).

var InnerTableElement = React.forwardRef(function (props, ref) {
  var _useStyletron3 = (0, _index3.useStyletron)(),
      _useStyletron4 = _slicedToArray(_useStyletron3, 2),
      useCss = _useStyletron4[0],
      theme = _useStyletron4[1];

  var ctx = React.useContext(HeaderContext); // no need to render the cells until the columns have been measured

  if (!ctx.widths.filter(Boolean).length) {
    return null;
  }

  return React.createElement("div", {
    ref: ref,
    "data-baseweb": "data-table",
    style: props.style
  }, React.createElement("div", {
    className: useCss({
      position: 'sticky',
      top: 0,
      left: 0,
      width: "".concat(ctx.widths.reduce(function (sum, w) {
        return sum + w;
      }, 0), "px"),
      height: '48px',
      display: 'flex',
      // this feels bad.. the absolutely positioned children elements
      // stack on top of this element with the layer component.
      zIndex: 2
    })
  }, ctx.columns.map(function (column, columnIndex) {
    var width = ctx.widths[columnIndex];
    return React.createElement("div", {
      className: useCss(_objectSpread({}, theme.borders.border200, {
        backgroundColor: theme.colors.mono100,
        borderTop: 'none',
        borderLeft: 'none',
        boxSizing: 'border-box'
      })),
      key: columnIndex,
      style: {
        width: width
      }
    }, React.createElement(_headerCell["default"], {
      index: columnIndex,
      filterable: column.filterable,
      sortable: column.sortable,
      isHovered: ctx.headerHoverIndex === columnIndex,
      isFilterOpen: ctx.filterOpenIndex === columnIndex,
      onFilterOpen: function onFilterOpen() {
        return ctx.onFilterOpen(columnIndex);
      },
      onFilterClose: function onFilterClose() {
        return ctx.onFilterClose();
      },
      isSelectable: ctx.isSelectable && columnIndex === 0,
      isSelectedAll: ctx.isSelectedAll,
      isSelectedIndeterminate: ctx.isSelectedIndeterminate,
      onMouseEnter: function onMouseEnter() {
        return ctx.onMouseEnter(columnIndex);
      },
      onMouseLeave: function onMouseLeave() {
        return ctx.onMouseLeave();
      },
      onSelectAll: ctx.onSelectAll,
      onSelectNone: ctx.onSelectNone,
      onSort: ctx.handleSort,
      filter: function filter(_ref2) {
        var close = _ref2.close;
        var Filter = column.renderFilter;
        return React.createElement(Filter, {
          setFilter: function setFilter(filterParams, description) {
            ctx.addFilter(filterParams, column.title, description);
          },
          data: ctx.rows.map(function (r) {
            return r.data[columnIndex];
          }),
          close: close
        });
      },
      sortDirection: ctx.sortIndex === columnIndex ? ctx.sortDirection : null,
      title: column.title
    }));
  })), React.Children.toArray(props.children).length <= ctx.columns.length ? React.createElement("div", {
    className: useCss(_objectSpread({}, theme.typography.font100, {
      marginTop: theme.sizing.scale600,
      marginLeft: theme.sizing.scale600
    }))
  }, "No rows match the filter criteria defined. Please remove one or more filters to view more data.") : props.children);
});
InnerTableElement.displayName = 'InnerTableElement';

function QueryInput(props) {
  var _useStyletron5 = (0, _index3.useStyletron)(),
      _useStyletron6 = _slicedToArray(_useStyletron5, 2),
      css = _useStyletron6[0],
      theme = _useStyletron6[1];

  var _React$useState5 = React.useState(''),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      value = _React$useState6[0],
      setValue = _React$useState6[1];

  React.useEffect(function () {
    var timeout = setTimeout(function () {
      return props.onChange(value);
    }, 250);
    return function () {
      return clearTimeout(timeout);
    };
  }, [value]);
  return React.createElement("div", {
    className: css({
      width: '375px'
    })
  }, React.createElement(_index2.Input, {
    "aria-label": "Search by text",
    overrides: {
      Before: function Before() {
        return React.createElement("div", {
          className: css({
            display: 'flex',
            alignItems: 'center',
            paddingLeft: theme.sizing.scale500
          })
        }, React.createElement(_search["default"], {
          size: "18px"
        }));
      }
    },
    size: _index2.SIZE.compact,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    },
    value: value,
    clearable: true
  }));
}

function Unstable_DataTable(props) {
  var _useStyletron7 = (0, _index3.useStyletron)(),
      _useStyletron8 = _slicedToArray(_useStyletron7, 2),
      css = _useStyletron8[0],
      theme = _useStyletron8[1];

  useDuplicateColumnTitleWarning(props.columns);

  var _useSortParameters = useSortParameters(),
      _useSortParameters2 = _slicedToArray(_useSortParameters, 3),
      sortIndex = _useSortParameters2[0],
      sortDirection = _useSortParameters2[1],
      handleSort = _useSortParameters2[2];

  var _React$useState7 = React.useState(new Map()),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      filters = _React$useState8[0],
      setFilters = _React$useState8[1];

  var _React$useState9 = React.useState(props.columns.map(function () {
    return 0;
  })),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      widths = _React$useState10[0],
      setWidths = _React$useState10[1];

  var gridRef = React.useRef(null);

  var _React$useState11 = React.useState(-1),
      _React$useState12 = _slicedToArray(_React$useState11, 2),
      rowHoverIndex = _React$useState12[0],
      setRowHoverIndex = _React$useState12[1];

  var handleRowHover = React.useCallback(function (nextIndex) {
    if (nextIndex !== rowHoverIndex) {
      setRowHoverIndex(nextIndex);
    }
  }, [rowHoverIndex]);

  var _React$useState13 = React.useState(-1),
      _React$useState14 = _slicedToArray(_React$useState13, 2),
      filterOpenIndex = _React$useState14[0],
      setFilterOpenIndex = _React$useState14[1];

  function handleFilterOpen(columnIndex) {
    if (filterOpenIndex === columnIndex) {
      setFilterOpenIndex(-1);
    } else {
      setFilterOpenIndex(columnIndex);
    }
  }

  function handleFilterClose() {
    setFilterOpenIndex(-1);
  }

  var _React$useState15 = React.useState(-1),
      _React$useState16 = _slicedToArray(_React$useState15, 2),
      headerHoverIndex = _React$useState16[0],
      setHeaderHoverIndex = _React$useState16[1];

  function handleColumnHeaderMouseEnter(columnIndex) {
    setHeaderHoverIndex(columnIndex);
    setRowHoverIndex(-1);

    if (columnIndex !== filterOpenIndex) {
      setFilterOpenIndex(-1);
    }
  }

  function handleColumnHeaderMouseLeave() {
    setHeaderHoverIndex(-1);
  }

  var _React$useState17 = React.useState(''),
      _React$useState18 = _slicedToArray(_React$useState17, 2),
      textQuery = _React$useState18[0],
      setTextQuery = _React$useState18[1];

  var sortedIndices = React.useMemo(function () {
    var toSort = props.rows.map(function (r, i) {
      return [r, i];
    });

    if (sortIndex !== -1) {
      var sortFn = props.columns[sortIndex].sortFn;

      if (sortDirection === _constants.SORT_DIRECTIONS.DESC) {
        toSort.sort(function (a, b) {
          return sortFn(a[0].data[sortIndex], b[0].data[sortIndex]);
        });
      } else if (sortDirection === _constants.SORT_DIRECTIONS.ASC) {
        toSort.sort(function (a, b) {
          return sortFn(b[0].data[sortIndex], a[0].data[sortIndex]);
        });
      }
    }

    return toSort.map(function (el) {
      return el[1];
    });
  }, [sortIndex, sortDirection, props.columns, props.rows]);
  var filteredIndices = React.useMemo(function () {
    var set = new Set(props.rows.map(function (_, idx) {
      return idx;
    }));
    Array.from(filters, function (f) {
      return f;
    }).forEach(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          title = _ref4[0],
          filter = _ref4[1];

      var columnIndex = props.columns.findIndex(function (c) {
        return c.title === title;
      });
      var column = props.columns[columnIndex];

      if (!column) {
        return;
      }

      var filterFn = column.buildFilter(filter.filterParams);
      Array.from(set).forEach(function (idx) {
        if (!filterFn(props.rows[idx].data[columnIndex])) {
          set["delete"](idx);
        }
      });
    });

    if (textQuery) {
      var stringishColumnIndices = [];

      for (var i = 0; i < props.columns.length; i++) {
        if (props.columns[i].kind === _constants.COLUMNS.CATEGORICAL || props.columns[i].kind === _constants.COLUMNS.STRING) {
          stringishColumnIndices.push(i);
        }
      }

      Array.from(set).forEach(function (idx) {
        var matches = stringishColumnIndices.some(function (cdx) {
          return props.rows[idx].data[cdx].toLowerCase().includes(textQuery);
        });

        if (!matches) {
          set["delete"](idx);
        }
      });
    }

    return set;
  }, [filters, textQuery, props.columns, props.rows]);
  var rows = React.useMemo(function () {
    return sortedIndices.filter(function (idx) {
      return filteredIndices.has(idx);
    }).map(function (idx) {
      return props.rows[idx];
    });
  }, [sortedIndices, filteredIndices, props.rows]);

  function addFilter(filterParams, title, description) {
    filters.set(title, {
      filterParams: filterParams,
      description: description
    });
    setFilters(new Map(filters));
  }

  function removeFilter(title) {
    filters["delete"](title);
    setFilters(new Map(filters));
  }

  var _React$useState19 = React.useState(new Set()),
      _React$useState20 = _slicedToArray(_React$useState19, 2),
      selectedRows = _React$useState20[0],
      setSelectedRows = _React$useState20[1];

  var isSelectable = props.batchActions ? !!props.batchActions.length : false;

  function handleSelectAll() {
    // only adds rows that are visible in the table
    handleSelectChange(new Set([].concat(_toConsumableArray(selectedRows), _toConsumableArray(rows.map(function (r) {
      return r.id;
    })))));
  }

  function handleSelectNone() {
    handleSelectChange(new Set());
  }

  function handleSelectChange(next) {
    setSelectedRows(next);
    var selectionCallback = props.onSelectionChange;

    if (selectionCallback) {
      selectionCallback(rows.filter(function (r) {
        return next.has(r.id);
      }));
    }
  }

  var handleRowSelect = React.useCallback(function (id) {
    if (selectedRows.has(id)) {
      selectedRows["delete"](id);
    } else {
      selectedRows.add(id);
    }

    handleSelectChange(new Set(selectedRows));
  }, [selectedRows]);
  var isRowSelected = React.useCallback(function (id) {
    return selectedRows.has(id);
  }, [selectedRows]);
  var itemData = React.useMemo(function () {
    return {
      headerHoverIndex: headerHoverIndex,
      rowHoverIndex: rowHoverIndex,
      isRowSelected: isRowSelected,
      isSelectable: isSelectable,
      onRowHover: handleRowHover,
      onSelect: handleRowSelect,
      columns: props.columns,
      rows: rows,
      textQuery: textQuery
    };
  }, [handleRowHover, handleRowSelect, headerHoverIndex, isRowSelected, isSelectable, props.columns, rowHoverIndex, rows, textQuery]);
  var headlineRef = React.useRef(null);

  var _React$useState21 = React.useState(64),
      _React$useState22 = _slicedToArray(_React$useState21, 2),
      headlineHeight = _React$useState22[0],
      setHeadlineHeight = _React$useState22[1];

  useResizeObserver(headlineRef, function (entries) {
    setHeadlineHeight(entries[0].contentRect.height);
  });
  return React.createElement(React.Fragment, null, React.createElement(_measureColumnWidths["default"], {
    columns: props.columns,
    rows: props.rows,
    widths: widths,
    isSelectable: isSelectable,
    onWidthsChange: function onWidthsChange(nextWidths) {
      setWidths(nextWidths);

      if (gridRef.current) {
        // $FlowFixMe trigger react-window to layout the elements again
        gridRef.current.resetAfterColumnIndex(0, true);
      }
    }
  }), React.createElement("div", {
    className: css({
      height: "".concat(headlineHeight, "px")
    })
  }, React.createElement("div", {
    ref: headlineRef
  }, !selectedRows.size && React.createElement("div", {
    className: css({
      alignItems: 'baseline',
      display: 'flex',
      flexWrap: 'wrap',
      paddingTop: theme.sizing.scale500,
      paddingBottom: theme.sizing.scale500
    })
  }, React.createElement(QueryInput, {
    onChange: setTextQuery
  }), Array.from(filters).map(function (_ref5) {
    var _ref6 = _slicedToArray(_ref5, 2),
        title = _ref6[0],
        filter = _ref6[1];

    return React.createElement(_index4.Tag, {
      key: title,
      onActionClick: function onActionClick() {
        return removeFilter(title);
      }
    }, React.createElement("span", {
      className: css(_objectSpread({}, theme.typography.font150, {
        color: theme.colors.mono1000
      }))
    }, title), ": ", filter.description);
  })), Boolean(selectedRows.size) && props.batchActions && React.createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      paddingTop: theme.sizing.scale400,
      paddingBottom: theme.sizing.scale400
    }
  }, props.batchActions.map(function (action) {
    function onClick(event) {
      action.onClick({
        clearSelection: handleSelectNone,
        event: event,
        selection: rows.filter(function (r) {
          return selectedRows.has(r.id);
        })
      });
    }

    if (action.renderIcon) {
      var Icon = action.renderIcon;
      return React.createElement(_index.Button, {
        key: action.label,
        overrides: {
          BaseButton: {
            props: {
              'aria-label': action.label
            }
          }
        },
        onClick: onClick,
        kind: _index.KIND.tertiary,
        shape: _index.SHAPE.round
      }, React.createElement(Icon, {
        size: 16
      }));
    }

    return React.createElement(_index.Button, {
      key: action.label,
      onClick: onClick,
      kind: _index.KIND.secondary,
      size: _index.SIZE.compact
    }, action.label);
  })))), React.createElement(_reactVirtualizedAutoSizer["default"], null, function (_ref7) {
    var height = _ref7.height,
        width = _ref7.width;
    return React.createElement(HeaderContext.Provider, {
      value: {
        columns: props.columns,
        rows: props.rows,
        addFilter: addFilter,
        filterOpenIndex: filterOpenIndex,
        handleSort: handleSort,
        headerHoverIndex: headerHoverIndex,
        isSelectable: isSelectable,
        isSelectedAll: !!rows.length && selectedRows.size >= rows.length,
        isSelectedIndeterminate: !!selectedRows.size && selectedRows.size < rows.length,
        onFilterOpen: handleFilterOpen,
        onFilterClose: handleFilterClose,
        onMouseEnter: handleColumnHeaderMouseEnter,
        onMouseLeave: handleColumnHeaderMouseLeave,
        onSelectAll: handleSelectAll,
        onSelectNone: handleSelectNone,
        sortDirection: sortDirection,
        sortIndex: sortIndex,
        widths: widths
      }
    }, React.createElement(_reactWindow.VariableSizeGrid // eslint-disable-next-line flowtype/no-weak-types
    , {
      ref: gridRef,
      overscanRowCount: 10,
      innerElementType: InnerTableElement,
      columnCount: props.columns.length,
      columnWidth: function columnWidth(columnIndex) {
        return widths[columnIndex];
      },
      height: height - headlineHeight // plus one to account for additional header row
      ,
      rowCount: rows.length + 1,
      rowHeight: function rowHeight(rowIndex) {
        return rowIndex === 0 ? 48 : 36;
      },
      width: width,
      itemData: itemData,
      style: _objectSpread({}, theme.borders.border200, {
        borderColor: theme.colors.mono500
      })
    }, CellPlacementMemo));
  }));
}